//=============================================================================
// Change_AttackEx_MZ.js
//   Last update: 2024/09/22
//=============================================================================
// 更新っぽいもの
// 
// 2024/09/22 [v0.1.0]
// 初版

/*:
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] Change!! AttackEx MZ.
 * 
 * @author Diamond
 *
 * @param Attack 4 All Judg Skill ID
 * @text ????
 * @default 168
 * @type skill
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Attack 4 All Main Skill ID
 * @text ????
 * @default 4
 * @type skill
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 * 
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 * 
 * @url https://diamond.iza-yoi.net/
 */

/*:ja
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] 真（チェンジ！！）通常攻撃の拡張 MZ
 * 
 * @author 貪藻矢射妥←
 *
 * @param Attack 4 All Judg Skill ID
 * @text 通常攻撃（敵全体）の判定用スキルID
 * @default 168
 * @type skill
 * @desc 特徴のスキル追加で使用する「全体攻撃」判定用スキルID
 *
 * @param Attack 4 All Main Skill ID
 * @text 通常攻撃（敵全体）の本体のスキルID
 * @default 4
 * @type skill
 * @desc 実際に通常攻撃（敵全体）を行うスキルID
 *
 * @help
 * 通常攻撃を拡張します。
 * 
 * ・通常攻撃で敵全体を攻撃
 * 通常攻撃もデータベ―ス上はスキルであり、やっていることは敵全体を攻撃する
 * 通常攻撃のスキルを使うだけというもの。
 * 
 * ややこしいですが、特徴のスキル追加で「全体攻撃」のスキルを習得している間
 * 通常攻撃というスキルではなく通常攻撃（敵全体）を使うようになります。
 * 
 * 通常攻撃が全体攻撃で1回攻撃の武器は好きですか？
 * ※どこのラノベタイトルやねん！
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 * 
 * @url https://diamond.iza-yoi.net/
 */


var OuterFlg = OuterFlg || {};

(() => {

'use strict';

OuterFlg.imported = OuterFlg.imported || {};
OuterFlg.imported['AttackEx'] = true;

var pluginParams                = PluginManager.parameters('Change_AttackEx_MZ');
var changeAttackEx4AllJudgSkillId = Number(pluginParams['Attack 4 All Judg Skill ID'] || 168);
var changeAttackEx4AllMainSkillId = Number(pluginParams['Attack 4 All Main Skill ID'] || 4);

//var ParamsEx          = PluginManagerEx.createParameter(document.currentScript);
//var ParamsEx_hogehoge = ParamsEx['hogehogeStruct'];


//-----------------------------------------------------------------------------
// Game_Action

Game_Action.prototype.setAttack4All = function() {
    this.setSkill(changeAttackEx4AllMainSkillId);
};


//-----------------------------------------------------------------------------
// Scene_Battle

Scene_Battle.prototype.commandAttack = function() {
    const action = BattleManager.inputtingAction();
    
    if ( action.subject().isActor() && 
         action.subject().skills().includes($dataSkills[changeAttackEx4AllJudgSkillId]) ) {
        action.setAttack4All();
    } else {
        action.setAttack();
    }
    this.onSelectAction();
};


})();
